/* MIT License
 *  
 * Copyright (c) 2020, Oracle and/or its affiliates. 
 * Copyright (c) 2019 pyhandle
 *  
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *  
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *  
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */


/*
   DO NOT EDIT THIS FILE!

   This file is automatically generated by tools/autogen.py from tools/public_api.h.
   Run this to regenerate:
       make autogen

*/

struct _HPyContext_s {
    int ctx_version;
    HPy h_None;
    HPy h_True;
    HPy h_False;
    HPy h_ValueError;
    HPy h_TypeError;
    HPy h_BaseObjectType;
    HPy h_TypeType;
    HPy h_LongType;
    HPy h_UnicodeType;
    HPy h_TupleType;
    HPy h_ListType;
    void* (*ctx_Module_Create)(HPyContext ctx, HPyModuleDef *def);
    void* (*ctx_Dup)(HPyContext ctx, void* h);
    void (*ctx_Close)(HPyContext ctx, void* h);
    void* (*ctx_Long_FromLong)(HPyContext ctx, long value);
    void* (*ctx_Long_FromUnsignedLong)(HPyContext ctx, unsigned long value);
    void* (*ctx_Long_FromLongLong)(HPyContext ctx, long long v);
    void* (*ctx_Long_FromUnsignedLongLong)(HPyContext ctx, unsigned long long v);
    void* (*ctx_Long_FromSize_t)(HPyContext ctx, size_t value);
    void* (*ctx_Long_FromSsize_t)(HPyContext ctx, HPy_ssize_t value);
    long (*ctx_Long_AsLong)(HPyContext ctx, void* h);
    void* (*ctx_Float_FromDouble)(HPyContext ctx, double v);
    double (*ctx_Float_AsDouble)(HPyContext ctx, void* h);
    HPy_ssize_t (*ctx_Length)(HPyContext ctx, void* h);
    int (*ctx_Number_Check)(HPyContext ctx, void* h);
    void* (*ctx_Add)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_Subtract)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_Multiply)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_MatrixMultiply)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_FloorDivide)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_TrueDivide)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_Remainder)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_Divmod)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_Power)(HPyContext ctx, void* h1, void* h2, void* h3);
    void* (*ctx_Negative)(HPyContext ctx, void* h1);
    void* (*ctx_Positive)(HPyContext ctx, void* h1);
    void* (*ctx_Absolute)(HPyContext ctx, void* h1);
    void* (*ctx_Invert)(HPyContext ctx, void* h1);
    void* (*ctx_Lshift)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_Rshift)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_And)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_Xor)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_Or)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_Index)(HPyContext ctx, void* h1);
    void* (*ctx_Long)(HPyContext ctx, void* h1);
    void* (*ctx_Float)(HPyContext ctx, void* h1);
    void* (*ctx_InPlaceAdd)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_InPlaceSubtract)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_InPlaceMultiply)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_InPlaceMatrixMultiply)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_InPlaceFloorDivide)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_InPlaceTrueDivide)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_InPlaceRemainder)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_InPlacePower)(HPyContext ctx, void* h1, void* h2, void* h3);
    void* (*ctx_InPlaceLshift)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_InPlaceRshift)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_InPlaceAnd)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_InPlaceXor)(HPyContext ctx, void* h1, void* h2);
    void* (*ctx_InPlaceOr)(HPyContext ctx, void* h1, void* h2);
    void (*ctx_Err_SetString)(HPyContext ctx, void* h_type, const char *message);
    int (*ctx_Err_Occurred)(HPyContext ctx);
    void* (*ctx_Err_NoMemory)(HPyContext ctx);
    int (*ctx_IsTrue)(HPyContext ctx, void* h);
    void* (*ctx_Type_FromSpec)(HPyContext ctx, HPyType_Spec *spec, HPyType_SpecParam *params);
    void* (*ctx_Type_GenericNew)(HPyContext ctx, void* type, HPy *args, HPy_ssize_t nargs, void* kw);
    void* (*ctx_GetAttr)(HPyContext ctx, void* obj, void* name);
    void* (*ctx_GetAttr_s)(HPyContext ctx, void* obj, const char *name);
    int (*ctx_HasAttr)(HPyContext ctx, void* obj, void* name);
    int (*ctx_HasAttr_s)(HPyContext ctx, void* obj, const char *name);
    int (*ctx_SetAttr)(HPyContext ctx, void* obj, void* name, void* value);
    int (*ctx_SetAttr_s)(HPyContext ctx, void* obj, const char *name, void* value);
    void* (*ctx_GetItem)(HPyContext ctx, void* obj, void* key);
    void* (*ctx_GetItem_i)(HPyContext ctx, void* obj, HPy_ssize_t idx);
    void* (*ctx_GetItem_s)(HPyContext ctx, void* obj, const char *key);
    int (*ctx_SetItem)(HPyContext ctx, void* obj, void* key, void* value);
    int (*ctx_SetItem_i)(HPyContext ctx, void* obj, HPy_ssize_t idx, void* value);
    int (*ctx_SetItem_s)(HPyContext ctx, void* obj, const char *key, void* value);
    void *(*ctx_Cast)(HPyContext ctx, void* h);
    void* (*ctx_New)(HPyContext ctx, void* h_type, void **data);
    void* (*ctx_Repr)(HPyContext ctx, void* obj);
    void* (*ctx_Str)(HPyContext ctx, void* obj);
    void* (*ctx_ASCII)(HPyContext ctx, void* obj);
    void* (*ctx_Bytes)(HPyContext ctx, void* obj);
    void* (*ctx_RichCompare)(HPyContext ctx, void* v, void* w, int op);
    int (*ctx_RichCompareBool)(HPyContext ctx, void* v, void* w, int op);
    HPy_hash_t (*ctx_Hash)(HPyContext ctx, void* obj);
    int (*ctx_Bytes_Check)(HPyContext ctx, void* h);
    HPy_ssize_t (*ctx_Bytes_Size)(HPyContext ctx, void* h);
    HPy_ssize_t (*ctx_Bytes_GET_SIZE)(HPyContext ctx, void* h);
    char *(*ctx_Bytes_AsString)(HPyContext ctx, void* h);
    char *(*ctx_Bytes_AS_STRING)(HPyContext ctx, void* h);
    void* (*ctx_Unicode_FromString)(HPyContext ctx, const char *utf8);
    int (*ctx_Unicode_Check)(HPyContext ctx, void* h);
    void* (*ctx_Unicode_AsUTF8String)(HPyContext ctx, void* h);
    void* (*ctx_Unicode_FromWideChar)(HPyContext ctx, const wchar_t *w, HPy_ssize_t size);
    int (*ctx_List_Check)(HPyContext ctx, void* h);
    void* (*ctx_List_New)(HPyContext ctx, HPy_ssize_t len);
    int (*ctx_List_Append)(HPyContext ctx, void* h_list, void* h_item);
    int (*ctx_Dict_Check)(HPyContext ctx, void* h);
    void* (*ctx_Dict_New)(HPyContext ctx);
    int (*ctx_Dict_SetItem)(HPyContext ctx, void* h_dict, void* h_key, void* h_val);
    void* (*ctx_Dict_GetItem)(HPyContext ctx, void* h_dict, void* h_key);
    void (*ctx_FatalError)(HPyContext ctx, const char *message);
    void* (*ctx_Tuple_FromArray)(HPyContext ctx, HPy items[], HPy_ssize_t n);
    void* (*ctx_FromPyObject)(HPyContext ctx, cpy_PyObject *obj);
    cpy_PyObject *(*ctx_AsPyObject)(HPyContext ctx, void* h);
    void (*ctx_CallRealFunctionFromTrampoline)(HPyContext ctx, HPyFunc_Signature sig, void *func, void *args);
    void (*ctx_CallDestroyAndThenDealloc)(HPyContext ctx, void *func, cpy_PyObject *self);
    void* (*ctx_ListBuilder_New)(HPyContext ctx, HPy_ssize_t initial_size);
    void (*ctx_ListBuilder_Set)(HPyContext ctx, void* builder, HPy_ssize_t index, void* h_item);
    void* (*ctx_ListBuilder_Build)(HPyContext ctx, void* builder);
    void (*ctx_ListBuilder_Cancel)(HPyContext ctx, void* builder);
    void* (*ctx_TupleBuilder_New)(HPyContext ctx, HPy_ssize_t initial_size);
    void (*ctx_TupleBuilder_Set)(HPyContext ctx, void* builder, HPy_ssize_t index, void* h_item);
    void* (*ctx_TupleBuilder_Build)(HPyContext ctx, void* builder);
    void (*ctx_TupleBuilder_Cancel)(HPyContext ctx, void* builder);
};
